<script lang="ts">
  import type { Player, State } from "../server";
  import { CardFace } from "../server";
  import { isActing } from "./actions/actionUtils";
  import CardFront from "./CardFront.svelte";
  import Discards from "./Discards.svelte";
  import Favor from "./icons/Favor.svelte";
  import { send, receive } from "./util/crossfade";
  import { cardFace } from "./util/cardUtils";

  import { createActionDispatcher } from "./util/createActionDispatcher";
  const dispatchAction = createActionDispatcher();

  export let player: Player;
  export let state: State;

  let handleClick: null | ((idx: number) => void) = null;

  $: {
    if (state.phase.kind === "Choose" && state.phase.actor === player.id) {
      handleClick = (idx) => {
        dispatchAction({ kind: "Choose", played: idx });
      };
    } else if (
      state.phase.kind === "Draw2" &&
      state.phase.actor === player.id
    ) {
      handleClick = (idx) => {
        dispatchAction({ kind: "Draw2", returned: idx });
      };
    } else {
      handleClick = null;
    }
  }

  $: active = isActing(state.phase, player.id);

  function getCardStyle(cardCount: number, idx: number): string {
    let rotationStep = 15;
    let startRotation = (1 - cardCount) * (rotationStep / 2);
    let rotation = startRotation + rotationStep * idx;
    return `
      --card-rotation: ${rotation.toFixed(2)}deg;
    `;
  }
</script>

<div class="wrapper" class:active class:dead={player.hand.length === 0}>
  {#if player.hand.length > 0}
    <div class="hand">
      {#each player.hand as card, idx (card)}
        <div class="card" style={getCardStyle(player.hand.length, idx)}>
          <button
            disabled={handleClick === null ||
              (state.phase.kind === "Choose" &&
                (cardFace(card) === CardFace.C5 ||
                  cardFace(card) === CardFace.C7) &&
                player.hand.some((c) => cardFace(c) === CardFace.C8))}
            on:click={() => handleClick && handleClick(idx)}
          >
            <div out:send={{ key: card }} in:receive={{ key: card }}>
              <CardFront {card} />
            </div>
          </button>
        </div>
      {/each}
    </div>
  {/if}

  <gs6-player-box playerid={player.id} {active}>
    <div class="box-content">
      <Favor /> ✕ {player.score}
      {#if player.protected}
        <div class="protection">
          <span class="emoji">🛡</span>
        </div>
      {/if}
    </div>
  </gs6-player-box>

  <div class="discards">
    <Discards crossfade cards={player.discards} />
  </div>
</div>

<style>
  .dead {
    filter: grayscale(90%) opacity(80%);
  }
  .wrapper {
    position: relative;
    margin-top: 16em;
    margin-bottom: 5em;
  }

  .card {
    font-size: 110%;
    position: absolute;
    left: 50%;
    top: 0;
    transition: transform 0.2s;
    transform-origin: center 48em;
    transform: translate(-50%, -100%) translateY(-0.5rem)
      rotate(var(--card-rotation));
  }

  .hand button {
    text-align: inherit;
    line-height: inherit;
    font-size: inherit;
    background-color: inherit;
    border: 0;
    padding: 0;
    cursor: pointer;

    transition: transform 0.25s;
  }

  .hand button:disabled {
    cursor: default;
    color: inherit;
  }
  .active button:disabled {
    cursor: not-allowed;
  }

  .hand button:not(:disabled):hover,
  .hand button:not(:disabled):focus {
    transform: translateY(-1em);
  }

  .box-content {
    text-align: center;
  }

  .protection {
    font-size: 250%;

    position: absolute;
    left: 0;
    top: 50%;
    transform: translate(-50%, -50%) translateX(0.25rem);
  }

  .discards {
    font-size: 0.4rem;
    position: absolute;
    left: 50%;
    bottom: 0;
    transform: translate(-50%, 100%) translateY(-0.5rem);
  }
</style>
